#include <FastLED.h>
int QTI_L = 39, QTI_R = 36, Button_pin = 18, Ultrasonic_Pin = 27, distance = 0, Speed = 0;
CRGB leds[6];
void setup() {
  FastLED.addLeds<WS2812, 26, GRB>(leds, 6);
  FastLED.setBrightness(100);
  pinMode(QTI_L, INPUT);
  pinMode(QTI_R, INPUT);
  pinMode(Button_pin, INPUT);
  for (int i = 12; i <= 15; i++) { 
    ledcSetup(i, 5000, 8);          
    ledcAttachPin(i, i);           
  }
  while (digitalRead(Button_pin) == 1);
}
void Motor(int L1, int L2 , int R1, int R2) {
  ledcWrite(12, L1);
  ledcWrite(13, L2);
  ledcWrite(14, R1);
  ledcWrite(15, R2);
}

void Get_Distance() {
  pinMode(Ultrasonic_Pin, OUTPUT);
  digitalWrite(Ultrasonic_Pin, HIGH);
  delayMicroseconds(20);
  digitalWrite(Ultrasonic_Pin, LOW);
  pinMode(Ultrasonic_Pin, INPUT);
  int Time_Echo_us = pulseIn(Ultrasonic_Pin, HIGH);
  distance = Time_Echo_us / 58;
}
void Tracking() {
  int QTI_Max = digitalRead(QTI_L) * 2 + digitalRead(QTI_R); 
  switch (QTI_Max) {
    case 0:
      Motor(0, Speed, 0, Speed); 
      break;
    case 1:
      Motor(Speed, 0, Speed / 2, 0);
      break;
    case 2:
      Motor(Speed / 2, 0, Speed, 0);
      break;
    case 3:
      Motor(Speed + 40, 0, Speed + 40, 0);
      break;
  }
}
void loop() {
  Get_Distance();
  if (distance > 5 && distance < 30 ) {
    Speed = map(distance, 5, 30, 30, 160);
    CRGB myRGBcolor(255, 255, 0);
    fill_solid(leds, 6, myRGBcolor);
    FastLED.show();
    Tracking();
  }
  else {
    fill_solid(leds, 6, CRGB::Green);
    FastLED.show();
    Motor(0, 0, 0, 0);
  }
}
