#include <IRremote.h>
#include <FastLED.h>
#define RECV_PIN 19
IRrecv irrecv(RECV_PIN);
decode_results results;
CRGB leds[6];
CRGB myRGBcolor(0, 0, 0);
int state_L, state_N, Speed = 255;
int Button_pin = 18, Buzzer_pin = 33;
void setup() {
  Serial.begin(9600);
  FastLED.addLeds<WS2812, 26, GRB>(leds, 6); 
  FastLED.setBrightness(100);
  irrecv.enableIRIn();
  pinMode(RECV_PIN, INPUT);
  pinMode(Button_pin, INPUT);
  ledcSetup(2, 2000, 8);
  ledcAttachPin(Buzzer_pin, 2);
  for (int i = 12; i <= 15; i++) { 
    ledcSetup(i, 255, 8);          
    ledcAttachPin(i, i);           
  }
  while (digitalRead(Button_pin) == 1);
}

void Motor(int L1, int L2 , int R1, int R2) {
  ledcWrite(12, L1);
  ledcWrite(13, L2);
  ledcWrite(14, R1);
  ledcWrite(15, R2);
}
void IR_remote_control_car() {
  switch (state_N) {
    case 0xFF18E7:
      Motor(Speed, 0, Speed, 0);
      break;
    case 0xFF4AB5:
      Motor(0, Speed, 0, Speed);
      break;
    case 0xFF10EF:
      Motor(0, Speed, Speed, 0);
      break;
    case 0xFF5AA5:
      Motor(Speed, 0, 0, Speed);
      break;
  }
}
void IR_remote_control_lamp() {
  if (state_N == 0xFFA25D){
    CRGB myRGBcolor(255, 255, 255);
    fill_solid(leds, 6, myRGBcolor);
    FastLED.show();
  }
  else if (state_N == 0xFF629D){
    CRGB myRGBcolor(0, 0, 0);
    fill_solid(leds, 6, myRGBcolor);
    FastLED.show();
  }
  else if (state_N == 0xFFE21D){
    ledcWriteTone(2, 294);
  }
}
void loop() {
  if (irrecv.decode(&results)) {
    Serial.println(results.value, HEX);
    if (results.value == 0xFFFFFFFFF) {
      state_N = state_L;
    }
    else {
      state_N = results.value;
      state_L = results.value;
    }
    IR_remote_control_car();
    IR_remote_control_lamp();
    irrecv.resume();
  }
  else {
    Motor(0, 0, 0, 0);
    ledcWriteTone(2, 0);
  }
  delay(150);
}
