#include <IRremote.h>
#include <FastLED.h>
#define RECV_PIN 19
int Ultrasonic_Pin = 27, Buzzer_pin = 33, state_value = 0, mode_value = 0;
int distance, state_L, state_N;
IRrecv irrecv(RECV_PIN);
decode_results results;
CRGB leds[6];

void setup() {
  irrecv.enableIRIn();
  ledcSetup(2, 2000, 8);
  ledcAttachPin(Buzzer_pin, 2);
  FastLED.addLeds<WS2812, 26, GRB>(leds, 6);
  FastLED.setBrightness(255);
  pinMode(RECV_PIN, INPUT);
  for (int i = 12; i <= 15; i++) {
    ledcSetup(i, 255, 8);
    ledcAttachPin(i, i);
  }
}
void Get_Distance() {
  pinMode(Ultrasonic_Pin, OUTPUT);
  digitalWrite(Ultrasonic_Pin, HIGH);
  delayMicroseconds(20);
  digitalWrite(Ultrasonic_Pin, LOW);
  pinMode(Ultrasonic_Pin, INPUT);
  int Time_Echo_us = pulseIn(Ultrasonic_Pin, HIGH);
  distance = Time_Echo_us / 58;
}

void Motor(int L1, int L2 , int R1, int R2) {
  ledcWrite(12, L1);
  ledcWrite(13, L2);
  ledcWrite(14, R1);
  ledcWrite(15, R2);
}
void Advance() {
  Get_Distance();
  if (distance < 20) {
    Motor(0, 0, 0, 0);
    fill_solid(leds, 6, CRGB::Red);
    FastLED.setBrightness(255);
    FastLED.show();
    ledcWriteTone(2, 262);
    delay(300);
    FastLED.setBrightness(0);
    FastLED.show();
    ledcWriteTone(2, 0);
    delay(300);
  }
  else {
    fill_solid(leds, 6, CRGB::Green);
    FastLED.setBrightness(255);
    FastLED.show();
    Motor(150, 0, 150, 0);
  }
}
void IR_remote_control() {
  switch (state_N) {
    case 0xFF18E7:
      switch (mode_value){
        case 1:
          state_value = 1;
          break;
        case 0:
          state_value = 0;
          Motor(150, 0, 150, 0);
          break;
      }
      break;
    case 0xFF4AB5:
      state_value = 0;
      Motor(0, 150, 0, 150);
      break;
    case 0xFF10EF:
      state_value = 0;
      Motor(0, 150, 150, 0);
      break;
    case 0xFF5AA5:
      state_value = 0;
      Motor(150, 0, 0, 150);
      break;
  }
  if (state_value == 1){
    Advance();
  }
}
void loop() {
  if (irrecv.decode(&results)) {
    if (results.value == 0xFFFFFFFFF) {
      state_N = state_L;
    }
    else {
      state_N = results.value;
      state_L = results.value;
      delay(100);
    }
    IR_remote_control();
    irrecv.resume();
  }
  else {
    if (state_value == 1){
      Advance();
    }
    Motor(0, 0, 0, 0);
  }
  if (state_N == 0xFFA25D){
    mode_value = 1;
  }else if (state_N == 0xFF629D){
    mode_value = 0;
  }
  delay(150);
}
