#include <FastLED.h>
int distance = 0, Ultrasonic_Pin = 27, Button_pin = 18, Buzzer_pin = 33;
CRGB leds[6];

void setup() {
  for (int i = 12; i <= 15; i++) {  
    ledcSetup(i, 255, 8);           
    ledcAttachPin(i, i);            
  }
  ledcSetup(2, 2000, 8);
  ledcAttachPin(Buzzer_pin, 2);
  pinMode(Button_pin, INPUT);
  FastLED.addLeds<WS2812, 26, GRB>(leds, 6);
  FastLED.setBrightness(255);
  while (digitalRead(Button_pin) == 1);
}
void Get_Distance() {
  pinMode(Ultrasonic_Pin, OUTPUT);
  digitalWrite(Ultrasonic_Pin, HIGH);
  delayMicroseconds(20);
  digitalWrite(Ultrasonic_Pin, LOW);
  pinMode(Ultrasonic_Pin, INPUT);
  int Time_Echo_us = pulseIn(Ultrasonic_Pin, HIGH);
  distance = Time_Echo_us / 58;
}
void Motor(int L1, int L2 , int R1, int R2) {
  ledcWrite(12, L1);
  ledcWrite(13, L2);
  ledcWrite(14, R1);
  ledcWrite(15, R2);
}

void loop() {
  Get_Distance();
  if ((distance > 4) && (distance < 30)){
    int Speed = map(distance, 5, 50, 30, 100);
    Motor(Speed, 0, Speed, 0);
    fill_solid(leds, 6, CRGB::Red);
    FastLED.setBrightness(255);
    FastLED.show();
    ledcWriteTone(2, 262);
    delay(distance / 0.1);
    Motor(Speed, 0, Speed, 0);
    FastLED.setBrightness(0);
    FastLED.show();
    ledcWriteTone(2, 0);
    delay(distance / 0.1);
  }
  else if (distance < 5){
    FastLED.setBrightness(0);
    FastLED.show();
    ledcWriteTone(2, 0);
    Motor(0, 0, 0, 0);
  }
  else{
    Motor(100, 0, 100, 0);
  }
}
